// Win32DlgOpenCV.cpp : AvP[ṼGg |Cg`܂B
//

#include "stdafx.h"
#include "Win32DlgOpenCV.h"

#include <opencv\cv.h>
#include <opencv\highgui.h>

#include <opencv2\core\core.hpp>
#include <opencv2\highgui\highgui.hpp>

//t@C֘A
//iR[h̓}`oCgɐݒ肵j
TCHAR szOpenFileName[MAX_PATH];
TCHAR szSaveFileName[MAX_PATH];

int open_file_name_box(HWND);      //GetOpenFileName֐p
int save_file_name_box(HWND);      //GetSaveFileName֐p

//͉摜Ao͉摜
cv::Mat imgMatRead; //ǂݍݗpiǂݍ񂾉摜͂ɕێj
cv::Mat imgMatWrite; //ݗpiۑۂ͂ɑΏۉ摜ݒ肷邱Ɓj
cv::Mat imgMatFix; //\\

//WIN32 BMP֘A
HWND hwPic = NULL;
HDC hDC = NULL;
HDC hDCPic = NULL;

IplImage *imgFromOpenCV = NULL;
IplImage img;

BITMAPINFO bmpInfo;
unsigned long* bmpData = NULL;

void iplTobmp(const IplImage*, BITMAPINFO&, unsigned long*);

//ȉ̊e֐ɂ肽OpenCV̏Ă
//摜ۑꍇ͕ϐ imgMatWrite ɕۑΏۉ摜ݒ肷
//Ƃ͕ۑ{^ŕۑo

/*------------------------------------------------
 1
-------------------------------------------------*/
void func1(HWND hWnd)
{
	if (imgMatRead.rows == 0){
		MessageBox(hWnd, "摜ł", "G[", MB_OK);
		return;
	}

	//ǂݍ񂾉摜O[XP[Xɕϊĕ\
	cv::Mat grImg;
	cv::cvtColor(imgMatRead, grImg, CV_BGR2GRAY);
	cv::imshow("gray", grImg);

	//ۑp̉摜ɐݒ肷
	imgMatWrite = grImg;
}

/*------------------------------------------------
2
-------------------------------------------------*/
void func2(HWND hWnd)
{
	MessageBox(hWnd, "func2", "debug", MB_OK);
}

/*------------------------------------------------
3
-------------------------------------------------*/
void func3(HWND hWnd)
{
	MessageBox(hWnd, "func3", "debug", MB_OK);
}

/*------------------------------------------------
4
-------------------------------------------------*/
void func4(HWND hWnd)
{
	MessageBox(hWnd, "func4", "debug", MB_OK);
}

/*------------------------------------------------
5
-------------------------------------------------*/
void func5(HWND hWnd)
{
	MessageBox(hWnd, "func5", "debug", MB_OK);
}

/*------------------------------------------------
 I
-------------------------------------------------*/
void terminateProc()
{
	//OpenCVWindowsN[Y
	cv::destroyAllWindows();

	//摜̗̈̉
	if (imgFromOpenCV != NULL){
		HeapFree(GetProcessHeap(), 0, bmpData); //ꉞ
	}
}

/*----------------------------------------------
 _CAOvV[W
-----------------------------------------------*/
LRESULT CALLBACK DlgProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	int ret;
	RECT rect;
	
	float rateW, rateH, rate;
	int imgBoxWidth, imgBoxHeight;

	int id = LOWORD(wParam);

	switch (message)
	{
	case WM_INITDIALOG:                // _CAȌ

		hwPic = GetDlgItem(hDlg, IDC_PICTURE);
		hDC = GetDC(hwPic);

		return TRUE;

	case WM_PAINT:

		//ǂݍ݉摜̕\
		if (imgFromOpenCV != NULL){
			StretchDIBits(hDC,
				0, 0, imgFromOpenCV->width, imgFromOpenCV->height,
				0, 0, imgFromOpenCV->width, imgFromOpenCV->height,
				bmpData, &bmpInfo, DIB_RGB_COLORS, SRCCOPY);
		}

		break;

	case WM_COMMAND:
		switch (id)
		{
		case ID_READ:

			//摜ǂݍ
			ret = open_file_name_box(hDlg);

			if (ret == 0){
				imgMatRead = cv::imread((const std::string&)szOpenFileName, 1); //3`lJ[摜œǂݍ

				if (imgMatRead.rows == 0){
					MessageBox(hDlg, "摜t@Cł", "G[", MB_OK);
					return FALSE;
				}

				//TCỸ`FbN
				GetWindowRect(hwPic, &rect);

				imgBoxWidth = rect.right - rect.left;
				imgBoxHeight = rect.bottom - rect.top;

				rateW = (float)imgBoxWidth / (float)imgMatRead.cols;
				rateH = (float)imgBoxHeight / (float)imgMatRead.rows;

				rate = 1.0f;

				//kKvȏꍇ́Ac\悤ɏkĕ\
				if ((rateH < (float)1.0) || (rateW < (float)1.0))
				{
					if (rateH < rateW){
						rate = rateH;
					}
					else
					{
						rate = rateW;
					}
				}

				if (rate < 1.0f)
				{
					// INTER_LINERiftHg̃oCjAԁjł̃TCYύX
					cv::resize(imgMatRead, imgMatFix, cv::Size(), rate, rate);
					img = imgMatFix;
				}
				else
				{
					img = imgMatRead;
				}

				imgFromOpenCV = &img;

				imgMatWrite = imgMatRead;

				//
				if (bmpData != NULL){
					HeapFree(GetProcessHeap(), 0, bmpData);
				}

				//m
				bmpData = (LPDWORD)HeapAlloc(GetProcessHeap(), HEAP_ZERO_MEMORY, imgFromOpenCV->width * imgFromOpenCV->height * 4);

				//iplImageDIB֕ϊ
				iplTobmp(imgFromOpenCV, bmpInfo, bmpData);

				//܂͂ŕ`
				InvalidateRect(NULL, NULL, TRUE);

				//Ô߃bZ[W
				if (rate < 1.0f){
					MessageBox(hDlg, "摜kĕ\܂B", "摜\", MB_OK);
				}
			}

			break;

		case ID_SAVE:

			//摜`FbN
			if (imgMatWrite.rows == 0){
				MessageBox(hDlg, "摜ł", "G[", MB_OK);
				return FALSE;
			}

			//摜ۑ
			ret = save_file_name_box(hDlg);

			if (ret == 0){
				cv::imwrite((const std::string&)szSaveFileName,imgMatWrite);
			}

			break;

		case IDC_MYICON:                    // ~{^̏
			EndDialog(hDlg, IDOK);
			terminateProc();

			return TRUE;

		case ID_CLOSE:                   // {^̏
			EndDialog(hDlg, IDCANCEL);
			terminateProc();

			return TRUE;

		case ID_EXEC1:
			func1(hDlg);
			break;

		case ID_EXEC2:
			func2(hDlg);
			break;

		case ID_EXEC3:
			func3(hDlg);
			break;

		case ID_EXEC4:
			func4(hDlg);
			break;

		case ID_EXEC5:
			func5(hDlg);
			break;

		default:
			break;
		}
		break;
	}
	return FALSE;
}

//---------------------------------------------------------------
//IplImage BMP(DIB)֕ϊ
//(͂3`lJ[摜ƂOAȊO͓ǂ߂Ȃ)
//---------------------------------------------------------------
void iplTobmp(const IplImage* srcIplImage, BITMAPINFO& bmpInfo, unsigned long* bmpData)
{
	int width = srcIplImage->width;
	int height = srcIplImage->height;

	ZeroMemory(&bmpInfo, sizeof(bmpInfo));
	bmpInfo.bmiHeader.biSize = sizeof(BITMAPINFOHEADER);
	bmpInfo.bmiHeader.biWidth = width;
	bmpInfo.bmiHeader.biHeight = height;
	bmpInfo.bmiHeader.biPlanes = 1;
	bmpInfo.bmiHeader.biBitCount = 32;
	bmpInfo.bmiHeader.biCompression = BI_RGB;

	unsigned long pixel;
	unsigned char r, g, b;
	for (int i = 0; i < height; i++){
		for (int j = 0; j < width; j++){
			b = srcIplImage->imageData[srcIplImage->widthStep * i + j * 3];
			g = srcIplImage->imageData[srcIplImage->widthStep * i + j * 3 + 1];
			r = srcIplImage->imageData[srcIplImage->widthStep * i + j * 3 + 2];
			pixel = 0x00000000;
			pixel = (r << 16) + (g << 8) + b;
			bmpData[j + (height - i - 1) * width] = pixel;
		}
	}
}

/*-----------------------------------
	I[vt@C擾
-------------------------------------*/
int open_file_name_box(HWND hWnd)
{
	int i;

	OPENFILENAME ofn;
	memset(&ofn, 0, sizeof(OPENFILENAME));  // \̂̏

	ofn.lStructSize = sizeof(OPENFILENAME); //\̂̃TCY
	ofn.hwndOwner = hWnd;   //eEBhẼnh
	ofn.lpstrFilter = TEXT("All(*.*)\0*.*\0JPEGt@C(*.jpg)\0*.jpg\0PNGt@C(*.png)\0*.png\0\0"); //tB^[
	ofn.lpstrFile = szOpenFileName;     // tpXt@C
	ofn.nMaxFile = sizeof(szOpenFileName);      //tpXt@C̃TCY
	ofn.lpstrFileTitle = szOpenFileName;       //t@C
	ofn.nMaxFileTitle = sizeof(szOpenFileName);        //t@C̃TCY
	
	//t@Ĉݓ͋ | ǂݎ`FbN{bNX\Ȃ
	ofn.Flags = OFN_FILEMUSTEXIST | OFN_HIDEREADONLY;
	ofn.lpstrDefExt = TEXT("*");                    //ftHg̊gq
	ofn.lpstrTitle = TEXT("摜t@C̓Ǎ");      //^Cgo[ɕ\镶
	
	i = GetOpenFileName(&ofn);
	if (i == 0) {      //OK{^ĂȂ
		return 1;
	}
	
	///MessageBox(hWnd, szOpenFileName, TEXT("debug"), MB_OK);
	
	return 0;
}

/*-----------------------------------
	ۑt@C擾
-------------------------------------*/
int save_file_name_box(HWND hWnd)
{
	int i;
	OPENFILENAME ofn;
	
	memset(&ofn, 0, sizeof(OPENFILENAME));  // \̂̏

	ofn.lStructSize = sizeof(OPENFILENAME); //\̂̃TCY
	ofn.hwndOwner = hWnd;   //eEBhẼnh
	ofn.lpstrFilter = TEXT("All(*.*)\0*.*\0JPEGt@C(*.jpg)\0*.jpg\0PNGt@C(*.png)\0*.png\0\0"); //tB^[
	ofn.lpstrFile = szSaveFileName;     // tpXt@C
	ofn.nMaxFile = sizeof(szSaveFileName);      //tpXt@C̃TCY
	ofn.lpstrFileTitle = szSaveFileName;       //t@C
	ofn.nMaxFileTitle = sizeof(szSaveFileName);        //t@C̃TCY
	ofn.Flags = OFN_OVERWRITEPROMPT;        // ㏑mF_CAO̕\
	ofn.lpstrDefExt = TEXT("*");    //ftHg̊gq
	ofn.lpstrTitle = TEXT("摜t@C̕ۑ");        //^Cgo[ɕ\镶
	
	i = GetSaveFileName(&ofn);        //t@Ctĕۑ_CAO{bNX
	if (i == 0) {      //OK{^ĂȂ
		return 1;
	}

	////MessageBox(hWnd, szSaveFileName, TEXT("debug"), MB_OK);
	
	return 0;
}

/*-----------------------------------------------------
	C֐
-------------------------------------------------------*/
int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
	LPSTR lpCmdLine, int nCmdShow)
{
	DialogBox(hInstance, MAKEINTRESOURCE(IDD_MAIN_DIALOG), NULL, (DLGPROC)DlgProc);
	return 0;
}

